$(function () {
	Init_translate();
	make_header("camconfiguration");
	set_rcpopup();

	var locations;
	var resx = 0;
	var resy = 0;
	var dict = {};
	var multioptdict = {};
	var ident = 0;

	var countries;
	var regions;
	var selected_region = 0;
	var countriesds;
	var countryelem;

	
String.prototype.insert = function (index, string) {
  if (index > 0)
    return this.substring(0, index) + string + this.substring(index, this.length);

  return string + this;
};


	var loadPanel = $(".loadpanel").dxLoadPanel({
			shadingColor: "rgba(0,0,0,0.4)",
			position: {
				of: "#tooplate_main"
			},
			visible: false,
			showIndicator: true,
			showPane: true,
			shading: true,
			message:  DevExpress.localization.formatMessage("Restarting..."),
			closeOnOutsideClick: false

		}).dxLoadPanel("instance");

	var btroi;

	$.ajax({
		dataType: "json",
		url: pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=select&table=nlregion&maxvalues=250&dd"+ getStringNormalDate(new Date()),
		async: false,
		success: function (data) {

			regions = data;
		}
	});

	String.prototype.includes = function (str) {
		var returnValue = false;

		if (this.indexOf(str) !== -1) {
			returnValue = true;
		}

		return returnValue;
	}

	$.ajax({
		dataType: "json",
		url: pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=select&table=nllocation&maxvalues=250&dd"+ getStringNormalDate(new Date()),
		async: false,
		success: function (data) {

			locations = data;
		}
	});

	var locationsds = new DevExpress.data.DataSource({
			store: locations,
			key: "id",

		});

	var regionds = new DevExpress.data.DataSource({
			store: regions,
			key: "id",

		});

	$.ajax({
		dataType: "json",
		url: pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=getident",
		async: false,
		success: function (data) {

			ident = data;
		}
	});



	$("#restartserv").dxButton({

		type: "success",
		text: DevExpress.localization.formatMessage("Restart service"),
		onClick: function () {
			loadPanel.show();
			lp= loadPanel;
			restartapp();

		}

	});
	$("#restartdefault").dxButton({

		type: "default",
		text: DevExpress.localization.formatMessage("Restart default configuration"),
		onClick: function () {

			var result = DevExpress.ui.dialog.confirm(DevExpress.localization.formatMessage("Are you sure to restart default configuration?"), DevExpress.localization.formatMessage("Default configuration"));
			result.done(function (dialogResult) {
				if (dialogResult) {
					$.ajax({
						dataType: "json",
						url: pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=defaultcameraconfig",
						async: false

					});
					location.reload();
				}
			});

		}
	});

	$.getJSON(pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=select&table=nlconfcamera&maxvalues=250&camp0=cameraid&comp0=minor&value0=2&d="+ getStringNormalDate(new Date())).done(function (data) {

		$(".content_wrapper").append(" <div class='dx-fieldset-header cerrado' id='ROIheader' style= 'padding: 10px 40px; cursor: pointer;' >"+DevExpress.localization.formatMessage("Show Roi")+"hhhh</div> ");
		$(".content_wrapper").append(" <div class='dx-fieldset' id= 'fiedlROI'  ></div> ");

		$(".content_wrapper").append(" <div class='dx-fieldset-header cerrado' id='LH1' style= 'padding: 10px 40px; cursor: pointer;' >"+DevExpress.localization.formatMessage("Show Lanes")+"</div> ");
		$(".content_wrapper").append(" <div class='dx-fieldset' id= 'fiedlLANES'  ></div> ");
		$("#fiedlROI").hide();
		$("#fiedlLANES").hide();

		$("#LH1").click(function () {
			if ($("#LH1").hasClass("abierto")) {
				$(this).removeClass('abierto');
				$(this).addClass('cerrado');
				$("#fiedlLANES").hide();

			} else {
				$(this).addClass('abierto');
				$(this).removeClass('cerrado');
				$("#fiedlLANES").show();

			}

		});

		//First bucle to create checkbox and div
		$.each(data, function (i, item) {

			if (item.grouppar != "") {

				if (typeof dict[item.grouppar] === "undefined") {

					item.indexg = i;
					dict[item.grouppar] = i;

					var toadd = "<div class='dx-fieldset-header cerrado' id='group" + i + "' style= 'padding: 10px 40px; cursor: pointer;' >" +DevExpress.localization.formatMessage( item.grouppar) + "</div> ";

					toadd += "<div class='dx-fieldset' id= 'fiedl" + i + "'  ></div>";

					$(".content_wrapper").append(toadd);
					$("#fiedl" + i).hide();

					$("#group" + i).click(function () {
						if ($("#group" + i).hasClass("abierto")) {
							$(this).removeClass('abierto');
							$(this).addClass('cerrado');
							$("#fiedl" + i).hide();
							listplatesabierto = false;
						} else {
							$(this).addClass('abierto');
							$(this).removeClass('cerrado');
							$("#fiedl" + i).show();
							listplatesabierto = true;
						}

					});

				} else {
					item.indexg = dict[item.grouppar];
				}

			} else {
				item.indexg = -1;
			}

		});

		$.each(data, function (i, item) {

			if (item.visible == 1) {

				if (item.typepar == "int") {

					var normalexper = "";

					if (item.indexg == -1) {
						normalexper = "#field";
					} else {
						normalexper = "#fiedl" + item.indexg;
					}

					$(normalexper).append(" <div class='dx-field'><div class='dx-field-label'>" + DevExpress.localization.formatMessage(item.text) + "</div><div class='dx-field-value'><div id='elem" + i + "'></div></div></div>");
					var valopt = (item.options).split(";");

					$("#elem" + i).dxNumberBox({
						value: item.value,
						min: valopt[0],
						max: valopt[1],
						showSpinButtons: true,
						onValueChanged: function (e) {
							var previousValue = e.previousValue;
							var newValue = e.value;
							// Event handling commands go here
							var jqxhr = $.ajax(pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=update&table=nlconfcamera&camp0=id&value0=" + item.id + "&camp1=value&value1=" + newValue + "&camp2=computerid&value2=" + item.computerid + "&camp3=cameraid&value3=" + item.cameraid+"&d="+ getStringNormalDate(new Date()))
								.done(function () {
									DevExpress.ui.notify("Data saved", "success", 600);
								})
								.fail(function () {
									DevExpress.ui.notify("Data saving error", "error", 600);
								});

						}
					});
				} else if (item.typepar == "multioption") {

					var normalexper = "";

					if (item.indexg == -1) {
						normalexper = "#field";
					} else {
						normalexper = "#fiedl" + item.indexg;
					}

					$(normalexper).append(" <div class='dx-field'><div class='dx-field-label'>" + item.text + "</div><div class='dx-field-value' id='multioption" + i + "'></div></div>");

					var valopt = (item.options).split(";");
					var valvalue = (item.value).split(";");

					multioptdict["multioption" + i] = [];
					$.each(valvalue, function (k, itemvalue) {
						multioptdict["multioption" + i].push(itemvalue);
					});

					$.each(valopt, function (j, itemoptions) {
						$("#multioption" + i).append("<div id='elem" + i + "-" + j + "' style='float: left;margin-right: 10px;' ></div>");

						$("#elem" + i + "-" + j).dxCheckBox({
							value: item.value.includes(itemoptions),
							text: itemoptions,
							onValueChanged: function (e) {

								var newValue = e.value;
								if (newValue) {
									multioptdict["multioption" + i].push(e.element[0].textContent);
								} else {
									var index = multioptdict["multioption" + i].indexOf(e.element[0].textContent);
									if (index > -1) {
										multioptdict["multioption" + i].splice(index, 1);
									}
								}

								var jqxhr = $.ajax(pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=update&table=nlconfcamera&camp0=id&value0=" + item.id + "&camp1=value&value1=" + multioptdict["multioption" + i].toString().replace(/,/g, ';') + "&camp2=computerid&value2=" + item.computerid + "&camp3=cameraid&value3=" + item.cameraid+"&d="+ getStringNormalDate(new Date()))
									.done(function () {
										DevExpress.ui.notify("Data saved", "success", 600);
									})
									.fail(function () {
										DevExpress.ui.notify("Data saving error", "error", 600);
									});

							}
						});

					});

				} else if (item.typepar == "nllocation") {
					var normalexper = "";
					if (item.indexg == -1) {
						normalexper = "#field";
					} else {
						normalexper = "#fiedl" + item.indexg;
					}
					$(normalexper).append(" <div class='dx-field'><div class='dx-field-label'>" + item.text + "</div><div class='dx-field-value'><div id='location'></div></div></div>");

					$("#location").dxSelectBox({
						dataSource: locationsds,
						valueExpr: "id",
						searchEnabled: true,
						value: parseInt(item.value, 10),
						displayExpr: "description",
						onValueChanged: function (e) {
							var previousValue = e.previousValue;
							var newValue = e.value;

							// Event handling commands go here
							var jqxhr = $.ajax(pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=update&table=nlconfcamera&camp0=id&value0=" + item.id + "&camp1=value&value1=" + newValue + "&camp2=computerid&value2=" + item.computerid + "&camp3=cameraid&value3=" + item.cameraid+"&d="+ getStringNormalDate(new Date()))
								.done(function () {
									DevExpress.ui.notify("Data saved", "success", 600);
								})
								.fail(function () {
									DevExpress.ui.notify("Data saving error", "error", 600);
								});

						}
					});

				} else if (item.typepar == "nlregion") {
					var normalexper = "";
					if (item.indexg == -1) {
						normalexper = "#field";
					} else {
						normalexper = "#fiedl" + item.indexg;
					}

					$(normalexper).append(" <div class='dx-field'><div class='dx-field-label'>" + DevExpress.localization.formatMessage(item.text) + "</div><div class='dx-field-value'><div id='region'></div></div></div>");

					$("#region").dxSelectBox({
						dataSource: regionds,
						valueExpr: "id",
						searchEnabled: true,
						value: parseInt(item.value, 10),
						displayExpr: "description",
						onValueChanged: function (e) {
							var previousValue = e.previousValue;
							var newValue = e.value;

							$.ajax({
								dataType: "json",
								url: pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=select&table=nlcountry&comp0=equal&camp0=regionid&value0=" + newValue + "&maxvalues=250"+"&d="+ getStringNormalDate(new Date()),
								async: false,
								success: function (data) {

									$("#country").dxTagBox("instance").option("dataSource", data);
									$("#country").dxTagBox("instance").reset();

								}
							});

						var jqxhr = $.ajax({
						url: pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=update&table=nlconfcamera&camp0=id&value0=2&camp1=value&value1=&camp2=computerid&value2=" + computerid + "&camp3=cameraid&value3=-1"+"&d="+ getStringNormalDate(new Date()),
						async: false,
						success: function (data) {
								DevExpress.ui.notify("Data saved", "success", 600);
							}
						});
						var jqxhr = $.ajax({
						url: pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=update&table=nlconfcamera&camp0=id&value0=" + item.id + "&camp1=value&value1=" + newValue + "&camp2=computerid&value2=" + item.computerid+ "&camp3=cameraid&value3=-1"+"&d="+ getStringNormalDate(new Date()),
						async: false,
						success: function (data) {
								DevExpress.ui.notify("Data saved", "success", 600);
							}
						});
							
					

						}
					});

					selected_region = item.value;

					$.ajax({
						dataType: "json",
						url: pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=select&table=nlcountry&comp0=equal&camp0=regionid&value0=" + selected_region + "&maxvalues=250"+"&d="+ getStringNormalDate(new Date()),
						async: false,
						success: function (data) {

							countriesds = new DevExpress.data.DataSource({
									store: data,
									key: "id",

								});
						}
					});

				} else if (item.typepar == "nlcountry") {
					var normalexper = "";
					if (item.indexg == -1) {
						normalexper = "#field";
					} else {
						normalexper = "#fiedl" + item.indexg;
					}
					$(normalexper).append(" <div class='dx-field'><div class='dx-field-label'>" + DevExpress.localization.formatMessage(item.text) + "</div><div class='dx-field-value'><div id='country'></div></div></div>");

					var valopt = (item.value).split(";");

					var valores = [];

					$.each(valopt, function (i, item) {
						valores.push(parseInt(item));
					});

					$("#country").dxTagBox({
						dataSource: countriesds,
						valueExpr: "id",
						searchEnabled: true,
						value: valores,
						displayExpr: "description",
						onValueChanged: function (e) {
							var previousValue = e.previousValue;
							var newValue = e.value;
							var counts = "";
							$.each(newValue, function (i, item) {
								counts += item + ";";
							});
							counts = counts.substring(0, counts.length - 1);

							// Event handling commands go here
							var jqxhr = $.ajax(pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=update&table=nlconfcamera&camp0=id&value0=" + item.id + "&camp1=value&value1=" + counts + "&camp2=computerid&value2=" + item.computerid+ "&camp3=cameraid&value3=-1"+"&d="+ getStringNormalDate(new Date()) )
								.done(function () {
									DevExpress.ui.notify("Data saved", "success", 600);
								})
								.fail(function () {
									DevExpress.ui.notify("Data saving error", "error", 600);
								})

						}
					});

				}

				if (item.typepar == "bool") {

					var normalexper = "";
					if (item.indexg == -1) {
						normalexper = "#field";
					} else {
						normalexper = "#fiedl" + item.indexg;
					}
					$(normalexper).append(" <div class='dx-field'><div class='dx-field-label'>" + DevExpress.localization.formatMessage(item.text) + "</div><div class='dx-field-value'><div id='elem" + i + "' style='float:none'></div></div></div>");
					var isTrueSet = (item.value == 'true');

					$("#elem" + i).dxCheckBox({
						value: isTrueSet,
						onValueChanged: function (e) {

							var previousValue = e.previousValue;
							var newValue = e.value;
							// Event handling commands go here
							var jqxhr = $.ajax(pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=update&table=nlconfcamera&camp0=id&value0=" + item.id + "&camp1=value&value1=" + newValue + "&camp2=computerid&value2=" + item.computerid + "&camp3=cameraid&value3=" + item.cameraid+"&d="+ getStringNormalDate(new Date()))
								.done(function () {
									DevExpress.ui.notify("Data saved", "success", 600);
								})
								.fail(function () {
									DevExpress.ui.notify("Data saving error", "error", 600);
								});

						}
					});
				}

				if (item.typepar == "info") {

					var normalexper = "";
					if (item.indexg == -1) {
						normalexper = "#field";
					} else {
						normalexper = "#fiedl" + item.indexg;
					}
					$(normalexper).prepend(" <div class='dx-field'><div class='dx-field-label'>" + DevExpress.localization.formatMessage(item.text) + "</div><div class='dx-field-value'><div id='elem" + i + "' style='float:none'></div><div id='popupinfo" + i + "' style='display:none' ></div></div></div>");

					var mh = 400;
					var mw = 500;

					if (item.help == "infoffcamera.html") {

						mh = 500;
						mw = 700;

					}

					$("#elem" + i).dxButton({
						icon: "help",
						type: "success",
						mode: "contained",
						onClick: function (e) {

							var jqxhr = $.ajax("help/" + item.help.replace(".html","_"+getLocale()+".html"))
								.done(function (data) {

									$("#popupinfo" + i).append(data);

									var poup = $("#popupinfo" + i).dxPopup({
											showTitle: true,
											title: DevExpress.localization.formatMessage("Help"),
											visible: true,
											maxWidth: mw,
											maxHeight: mh,
											loseOnOutsideClick: true
										});

								});

						}
					});

				}
				if (item.typepar == "string") {

					var normalexper = "";
					if (item.indexg == -1) {
						normalexper = "#field";
					} else {
						normalexper = "#fiedl" + item.indexg;
					}
					$(normalexper).append(" <div class='dx-field'><div class='dx-field-label'>" + DevExpress.localization.formatMessage(item.text) + "</div><div class='dx-field-value'><div id='elem" + i + "' style='float:none'></div></div></div>");

					$("#elem" + i).dxTextBox({
						value: item.value,
						onValueChanged: function (e) {
							var previousValue = e.previousValue;
							var newValue = e.value;

							newValue = newValue.replace(/\\/g, '/');

							// Event handling commands go here
							var jqxhr = $.ajax(pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=update&table=nlconfcamera&camp0=id&value0=" + item.id + "&camp1=value&value1=" + encodeURIComponent(newValue) + "&camp2=computerid&value2=" + item.computerid + "&camp3=cameraid&value3=" + item.cameraid+"&d="+ getStringNormalDate(new Date()))
								.done(function () {
									DevExpress.ui.notify("Data saved", "success", 600);
								})
								.fail(function () {
									DevExpress.ui.notify("Data saving error", "error", 600);
								});

						}
					});
				}
				if (item.typepar == "option") {
					var valopt = (item.options).split(";");
					var normalexper = "";
					if (item.indexg == -1) {
						normalexper = "#field";
					} else {
						normalexper = "#fiedl" + item.indexg;
					}

					var helpdiv = "";
					if (item.help != "") {
						helpdiv = "<div id='icon" + i + "'></div><div id='popup" + i + "' style='display:none' ></div> ";
					}
					var item_name = DevExpress.localization.formatMessage(item.text);
					
					
				
					
					
					$(normalexper).append(" <div class='dx-field'><div class='dx-field-label'>" + item_name + "</div><div class='dx-field-value'><div id='elem" + i + "' style='float:none;display: inline-block;'></div> " + helpdiv + "</div></div>");

					if (item.help != "") {
						var mh = 250;
						var mw = 500;
						if (item.help == "help_mode_camera.html")
						{
							mh=400;
							mw= 800;
						}

						$("#icon" + i).dxButton({
							icon: "help",
							type: "success",
							mode: "contained",
							onClick: function (e) {

								var jqxhr = $.ajax("help/" + item.help.replace(".html","_"+getLocale()+".html"))
									.done(function (data) {

										$("#popup" + i).append(data);

										var poup = $("#popup" + i).dxPopup({
												showTitle: true,
												title: DevExpress.localization.formatMessage("Help"),
												visible: true,
												maxWidth: mw,
												maxHeight: mh,
												loseOnOutsideClick: true
											});

									});

							}
						});

					}
					var isTrueSet = (item.value == 'true');

					if (item.text.includes("esolution")) {
						var resopt = (item.value).split("x");
						resx = resopt[0];
						resy = resopt[1];

					}

					$("#elem" + i).dxRadioGroup({

						items: valopt,
						value: item.value,
						layout: "horizontal",
						onValueChanged: function (e) {
							var previousValue = e.previousValue;
							var newValue = e.value;
							if (newValue.includes("x")) {
								var resopt = (newValue).split("x");
								resx = resopt[0];
								resy = resopt[1];
							
								
							}

							// Event handling commands go here
							var jqxhr = $.ajax(pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=update&table=nlconfcamera&camp0=id&value0=" + item.id + "&camp1=value&value1=" + newValue + "&camp2=computerid&value2=" + item.computerid + "&camp3=cameraid&value3=" + item.cameraid+"&d="+ getStringNormalDate(new Date()))
								.done(function () {
									DevExpress.ui.notify("Data saved", "success", 600);
								})
								.fail(function () {
									DevExpress.ui.notify("Data saving error", "error", 600);
								});

						}
					});
				}
				if (item.typepar == "roi") {

					var normalexper = "";
					if (item.indexg == -1) {
						normalexper = "#field";
					} else {
						normalexper = "#fiedl" + item.indexg;
					}

					$("#fiedlROI").append(" <div class='dx-field' id ='ROICANVAS'  ><div id='icon-done_info'></div><br><br><img src='./images/ROIGIF.gif'> <div class='dx-field-value' style= ' width:auto' ><canvas id='canvas' width='800' height='600' '></canvas><img id = 'mono' src=' " + pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=snapshot&resolution=800x600' width='800' height='600' style= 'visibility:hidden;display:none'></div></div>");

					$("#ROIheader").click(function () {
						if ($("#ROIheader").hasClass("abierto")) {
							$(this).removeClass('abierto');
							$(this).addClass('cerrado');
							$("#fiedlROI").hide();

						} else {
							$(this).addClass('abierto');
							$(this).removeClass('cerrado');
							$("#fiedlROI").show();

						}

					});

					var valopt = (item.value).split(";");
					var sroi = "";
					if (valopt[0] != 0 || valopt[1] != 0 || valopt[2] != 0 || valopt[3] != 0) {
						sroi = " (" + valopt[0] + ";" + valopt[1] + ";" + valopt[2] + ";" + valopt[3] + ")";
					}
					$("#ROIheader").text(DevExpress.localization.formatMessage("Show Roi") + sroi);

					btroi = $("#icon-done_info").dxButton({

							type: "success",
							text: DevExpress.localization.formatMessage("Reset ROI"),
							onClick: function () {

								resetROI();

							}
						}).dxButton('instance'); ;

					var canvas = document.getElementById('canvas');
					var ctx = canvas.getContext('2d');

					var img = document.getElementById("mono");

					var tmpImg = new Image();
					tmpImg.src = $('#mono').attr('src');
					tmpImg.onload = function () {
						ctx.drawImage(img, 0, 0);
						var ppcX= parseFloat("0."+valopt[0]);
						var ppcY= parseFloat("0."+valopt[1]);
						var ppcwidth= parseFloat("0."+valopt[2]);
						var ppcheight= parseFloat("0."+valopt[3]);
											
						
						ctx.rect(ppcX * 800 , ppcY * 600 , ppcwidth * 800 ,ppcheight * 600 );
						ctx.strokeStyle = 'red';
						ctx.lineWidth = 5;
						ctx.stroke();
					};

					//Variables


					var canvasx = $(canvas).offset().left;
					var canvasy = $(canvas).offset().top;
					var last_mousex = last_mousey = 0;
					var mousex = mousey = 0;
					var mousedown = false;
					//Mousedown
					$(canvas).on('mousedown', function (e) {
						last_mousex = e.offsetX;
						last_mousey = e.offsetY;
						mousedown = true;
					});

					//Mouseup
					$(canvas).on('mouseup', function (e) {
						mousedown = false;

						var initpointx,
						initpointy,
						endpointx,
						endpointy;

						mousex = e.offsetX;
						mousey = e.offsetY;

						if (mousex > last_mousex) {
							initpointx = last_mousex;
							endpointx = mousex;
						} else {
							initpointx = mousex;
							endpointx = last_mousex;
						}

						if (mousey > last_mousey) {
							initpointy = last_mousey;
							endpointy = mousey;
						} else {
							initpointy = mousey;
							endpointy = last_mousey;
						}

						var pointXReal = Math.round(initpointx * (resx / 800));
						var pointYReal = Math.round(initpointy * (resy / 600));

						var endpointXReal = Math.round(endpointx * (resx / 800));
						var endpointYReal = Math.round(endpointy * (resy / 600));

						if(pointXReal == endpointXReal ||  pointYReal == endpointYReal)
						{
							return;
						}
						
						
						if (pointXReal < 0) {
							pointXReal = 0;
						}
						if (pointYReal < 0) {
							pointYReal = 0;
						}

						var tpcx= (pointXReal /resx).toFixed(4); 
						var tpcy= (pointYReal /resy).toFixed(4); 
						var tpcwidth= ((endpointXReal - pointXReal) /resx).toFixed(4); 
						var tpcheigth= ((endpointYReal - pointYReal) /resy).toFixed(4); 
						
						var tpcx_dec= (tpcx+"").split(".")[1];
						var tpcy_dec= (tpcy+"").split(".")[1];
						var tpcwidth_dec= (tpcwidth+"").split(".")[1];
						var tpcheigth_dec= (tpcheigth+"").split(".")[1];
						
						
						
						var roi = tpcx_dec + ";" + tpcy_dec + ";" + tpcwidth_dec + ";" + tpcheigth_dec;

						
						
						
						$("#ROIheader").text(DevExpress.localization.formatMessage("Show Roi")+" (" + roi + ")");
						

						var jqxhr = $.ajax(pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=update&table=nlconfcamera&camp0=id&value0=" + item.id + "&camp1=value&value1=" + roi + "&camp2=computerid&value2=" + item.computerid + "&camp3=cameraid&value3=" + item.cameraid+"&d="+ getStringNormalDate(new Date()))
							.done(function () {
								DevExpress.ui.notify("Data saved", "success", 600);
							})
							.fail(function () {
								DevExpress.ui.notify("Data saving error", "error", 600);
							});
					});

					//Mousemove
					$(canvas).on('mousemove', function (e) {
						mousex = e.offsetX;
						mousey = e.offsetY;
						if (mousedown) {
							ctx.clearRect(0, 0, canvas.width, canvas.height); //clear canvas
							ctx.beginPath();
							var width = mousex - last_mousex;
							var height = mousey - last_mousey;
							ctx.rect(last_mousex, last_mousey, width, height);
							ctx.strokeStyle = 'red';
							ctx.lineWidth = 5;
							ctx.stroke();
							var img = document.getElementById("mono");
							ctx.drawImage(img, 0, 0);
							ctx.stroke();
						}

					});

				}

				if (item.typepar == "nlcameralane") {

					$.ajax({
						dataType: "json",
						url: pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=select&table=nlcameralane&maxvalues=250&dcl="+ getStringNormalDate(new Date()),
						async: false,
						success: function (data2) {

							var normalexper = "";
							if (item.indexg == -1) {
								normalexper = "#field";
							} else {
								normalexper = "#fiedl" + item.indexg;
							}

							$("#fiedlLANES").append(" <div class='dx-field' id ='LANECANVAS'  ><div id='ResetLan'></div><br><br><img src='./images/LANEGIF.gif'> <div class='dx-field-value' style= ' width:auto' ><canvas id='canvaslanes' width='800' height='600' ></canvas><img id = 'monolanes' src=' " + pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=snapshot&resolution=800x600' width='800' height='600' style= 'visibility:hidden;display:none'></div></div>");

							$("#ResetLan").dxButton({

								type: "success",
								text: DevExpress.localization.formatMessage("Delete Lanes"),
								onClick: function () {

									resetLANES();

								}
							});

							var canvas2 = document.getElementById('canvaslanes');
							var ctx2 = canvas2.getContext('2d');

							var img2 = document.getElementById("monolanes");

							var tmpImg2 = new Image();
							tmpImg2.src = $('#monolanes').attr('src');
							tmpImg2.onload = function () {
								ctx2.drawImage(img2, 0, 0);
								if (data2.length > 0) {
									var p0 ;
									var p1;
									
							
									p0 =  parseFloat(data2[0].lpoint00X / 10000)  * 800 ;
																		
									p1 =  parseFloat(data2[0].lpoint01X /10000)  * 800 ;
									
																					

									ctx2.moveTo(p0, 0);
									ctx2.lineTo(p1, 600);

									ctx2.strokeStyle = 'red';
									ctx2.lineWidth = 5;

									ctx2.font = "30px Arial";
									ctx2.fillStyle = "red";
									ctx2.textAlign = "left";
									ctx2.fillText("LANE1", 10, 25);
									ctx2.fillText("LANE2", 690, 25);

									$("#LH1").text(DevExpress.localization.formatMessage("Show Lanes")+" (" + data2[0].lpoint00X + ";" + data2[0].lpoint01X + ";" + data2[0].lpoint01X + ";" + data2[0].lpoint01Y + ")");
								}

								ctx2.stroke();
							};

							//Variables


							var canvasx2 = $(canvas2).offset().left;
							var canvasy2 = $(canvas2).offset().top;
							var last_mouse2x = last_mousey2 = 0;
							var mousex2 = mousey2 = 0;
							var mousedown2 = false;
							//Mousedown
							$(canvas2).on('mousedown', function (e) {
								last_mousex2 = e.offsetX;
								last_mousey2 = e.offsetY;
								mousedown2 = true;
							});

							//Mouseup
							$(canvas2).on('mouseup', function (e) {
								mousedown2 = false;

								var initpointx,
								initpointy,
								endpointx,
								endpointy;

								var initpointx1,
								initpointy1,
								endpointx1,
								endpointy1;

								mousex2 = e.offsetX;
								mousey2 = e.offsetY;

								initpointx1 = last_mousex2;
								endpointx1 = mousex2;

								initpointy1 = last_mousey2;
								endpointy1 = mousey2;

								if (initpointx1 <= endpointx1) {
									initpointx = initpointx1;
									initpointy = initpointy1;
									endpointx = endpointx1;
									endpointy = endpointy1;
								} else {
									initpointx = endpointx1;
									initpointy = endpointy1;
									endpointx = initpointx1;
									endpointy = initpointy1;

								}

								if ((endpointx - initpointx) == 0) {
									return;
								}

								var pendiente = (endpointy - initpointy) / (endpointx - initpointx);
								var b = endpointy - (pendiente * endpointx);

								ctx2.clearRect(0, 0, canvas2.width, canvas2.height); //clear canvas
								ctx2.beginPath();

								var x0 = (-b / pendiente);
								var x1 = (600 - b) / pendiente;

								ctx2.moveTo(x0, 0);
								ctx2.lineTo(x1, 600);

								ctx2.strokeStyle = 'red';
								ctx2.lineWidth = 5;
								ctx2.stroke();
								var img2 = document.getElementById("monolanes");
								ctx2.drawImage(img2, 0, 0);
								ctx2.font = "30px Arial";
								ctx2.fillStyle = "red";
								ctx2.textAlign = "left";
								ctx2.fillText("LANE1", 10, 25);
								ctx2.fillText("LANE2", 690, 25);
								ctx2.stroke();

								var pointXReal = Math.round(x0 * (resx / 800));

								var endpointXReal = Math.round(x1 * (resx / 800));
								var endpointYReal = resy;
								
								var ltpcx= (pointXReal /resx).toFixed(4); 
								var ltpcendx= (endpointXReal /resx).toFixed(4); 
								var ltpcendy= (endpointYReal /resy).toFixed(4); 
					
											
								var ltpcx_dec= ltpcx * 10000
								var ltpcendx_dec= ltpcendx *10000
								var ltpcendy_dec= ltpcendy *10000
								
							
								
								
								

								var lanestr = (ltpcx_dec + ";0;" + ltpcendx_dec + ";" + ltpcendy_dec);
								
								

								$("#LH1").text(DevExpress.localization.formatMessage("Show Lanes")+" (" + lanestr + ")");

								var jqxhr = $.ajax(pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=delete&table=nlcameralane&d="+ getStringNormalDate(new Date())).done(function () {
										var urlinsert = pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=insert&table=nlcameralane&camp0=id&value0=-1&camp1=sendserver&value1=0&camp2=dateserver&value2=20180101000000";
										urlinsert += "&camp3=reserve&value3=";
										urlinsert += "&camp4=cameraid&value4=1";
										urlinsert += "&camp5=computerid&value5=1";
										urlinsert += "&camp6=name&value6=LANE1";
										urlinsert += "&camp7=direction&value7=1";
										urlinsert += "&camp8=lpoint00X&value8=" + ltpcx_dec;
										urlinsert += "&camp9=lpoint00Y&value9=0";
										urlinsert += "&camp10=lpoint01X&value10=" + ltpcendx_dec;
										urlinsert += "&camp11=lpoint01Y&value11=" + ltpcendy_dec;
										urlinsert += "&camp12=lpoint10X&value12=0";
										urlinsert += "&camp13=lpoint10Y&value13=0";
										urlinsert += "&camp14=lpoint11X&value14=0";
										urlinsert += "&camp15=lpoint11Y&value15=0";
										urlinsert += "&camp16=occoming&value16=1";
										urlinsert += "&camp17=ocgoing&value17=1";
										urlinsert += "&camp18=enabled&value18=1";

										var jqxhr = $.ajax({
												url: urlinsert,
												async: false
											});

										var urlinsert2 = pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=insert&table=nlcameralane&camp0=id&value0=-1&camp1=sendserver&value1=0&camp2=dateserver&value2=20180101000000";
										urlinsert2 += "&camp3=reserve&value3=";
										urlinsert2 += "&camp4=cameraid&value4=1";
										urlinsert2 += "&camp5=computerid&value5=1";
										urlinsert2 += "&camp6=name&value6=LANE2";
										urlinsert2 += "&camp7=direction&value7=1";
										urlinsert2 += "&camp8=lpoint00X&value8=0";
										urlinsert2 += "&camp9=lpoint00Y&value9=0";
										urlinsert2 += "&camp10=lpoint01X&value10=0";
										urlinsert2 += "&camp11=lpoint01Y&value11=0";
										urlinsert2 += "&camp12=lpoint10X&value12=" + ltpcx_dec;
										urlinsert2 += "&camp13=lpoint10Y&value13=0";
										urlinsert2 += "&camp14=lpoint11X&value14=" + ltpcendx_dec;
										urlinsert2 += "&camp15=lpoint11Y&value15=" + ltpcendy_dec;
										urlinsert2 += "&camp16=occoming&value16=1";
										urlinsert2 += "&camp17=ocgoing&value17=1";
										urlinsert2 += "&camp18=enabled&value18=1";

										var jqxhr2 = $.ajax({
												url: urlinsert2,
												async: false
											});

										DevExpress.ui.notify("Data saved", "success", 600);
									})
									.fail(function () {
										DevExpress.ui.notify("Data saving error", "error", 600);
									});

							});

							//Mousemove
							$(canvas2).on('mousemove', function (e) {
								mousex2 = e.offsetX;
								mousey2 = e.offsetY;
								if (mousedown2) {
									ctx2.clearRect(0, 0, canvas2.width, canvas2.height); //clear canvas
									ctx2.beginPath();
									var width2 = mousex2 - last_mousex2;
									var height2 = mousey2 - last_mousey2;

									ctx2.moveTo(last_mousex2, last_mousey2);
									ctx2.lineTo(mousex2, mousey2);

									ctx2.strokeStyle = 'red';
									ctx2.lineWidth = 5;
									ctx2.stroke();
									var img2 = document.getElementById("monolanes");
									ctx2.drawImage(img2, 0, 0);
									ctx2.stroke();
								}

							});

						}
					});

				}
			}
		});

	});

	function resetROI() {
		var canvas = document.getElementById('canvas');
		var ctx = canvas.getContext('2d');
		ctx.clearRect(0, 0, canvas.width, canvas.height); //clear canvas
		ctx.beginPath();
		ctx.stroke();
		var img = document.getElementById("mono");
		ctx.drawImage(img, 0, 0);
		ctx.stroke();
		var roi = "0;0;0;0";

		$("#ROIheader").text(DevExpress.localization.formatMessage("Show Roi"));

		var jqxhr = $.ajax(pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=update&table=nlconfcamera&camp0=id&value0=5&camp1=value&value1=" + roi + "&camp2=computerid&value2="+ computerid +"&camp3=cameraid&value3=1"+"&d="+ getStringNormalDate(new Date()))
			.done(function () {
				DevExpress.ui.notify("Data saved", "success", 600);
			})
			.fail(function () {
				DevExpress.ui.notify("Data saving error", "error", 600);
			});
	}

	function resetLANES() {

		var canvas2 = document.getElementById('canvaslanes');
		var ctx2 = canvas2.getContext('2d');
		ctx2.clearRect(0, 0, canvas2.width, canvas2.height); //clear canvas
		ctx2.beginPath();
		ctx2.stroke();
		var img2 = document.getElementById("monolanes");
		ctx2.drawImage(img2, 0, 0);
		ctx2.stroke();

		$("#LH1").text(DevExpress.localization.formatMessage("Show Lanes"));

		var jqxhr = $.ajax(pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=delete&table=nlcameralane"+"&d="+ getStringNormalDate(new Date()))
			.done(function () {
				DevExpress.ui.notify("Data saved", "success", 600);
			})
			.fail(function () {
				DevExpress.ui.notify("Data saving error", "error", 600);
			});

	}

});
